- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# PK_Decryptor Class Reference

`#include <cryptlib.h>`

Inheritance diagram for PK_Decryptor:

List of all members.

## Detailed Description

interface for public-key decryptors

Definition at line 1186 of file cryptlib.h.

## Public Member Functions
virtual DecodingResult | Decrypt (RandomNumberGenerator &rng, const byte *ciphertext, size_t ciphertextLength, byte *plaintext, const NameValuePairs &parameters=g_nullNameValuePairs) const =0
| decrypt a byte string, and return the length of plaintext
virtual BufferedTransformation * | CreateDecryptionFilter (RandomNumberGenerator &rng, BufferedTransformation *attachment=NULL, const NameValuePairs &parameters=g_nullNameValuePairs) const
| create a new decryption filter
DecodingResult | FixedLengthDecrypt (RandomNumberGenerator &rng, const byte *ciphertext, byte *plaintext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| decrypt a fixed size ciphertext
virtual size_t | MaxPlaintextLength (size_t ciphertextLength) const =0
| maximum length of plaintext for a given ciphertext length
virtual size_t | CiphertextLength (size_t plaintextLength) const =0
| calculate length of ciphertext given length of plaintext
virtual bool | ParameterSupported (const char *name) const =0
| this object supports the use of the parameter with the given name
virtual size_t | FixedCiphertextLength () const
| return fixed ciphertext length, if one exists, otherwise return 0
virtual size_t | FixedMaxPlaintextLength () const
| return maximum plaintext length given the fixed ciphertext length, if one exists, otherwise return 0
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
virtual PrivateKey & | AccessPrivateKey ()=0
virtual const PrivateKey & | GetPrivateKey () const
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Member Function Documentation

virtual DecodingResult PK_Decryptor::Decrypt | ( | RandomNumberGenerator & | rng,
|  | const byte * | ciphertext,
|  | size_t | ciphertextLength,
|  | byte * | plaintext,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs` |
| ) |  |  | const`[pure virtual]`

decrypt a byte string, and return the length of plaintext

Precondition:
  size of plaintext == MaxPlaintextLength(ciphertextLength) bytes.

Returns:
  the actual length of the plaintext, indication that decryption failed.

Implemented in TF_DecryptorBase, DL_DecryptorBase< T >, and DL_DecryptorBase< SCHEME_OPTIONS::Element >.

Referenced by PK_DefaultDecryptionFilter::Put2().

BufferedTransformation * PK_Decryptor::CreateDecryptionFilter | ( | RandomNumberGenerator & | rng,
|  | BufferedTransformation * | attachment = `NULL`,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs` |
| ) |  |  | const`[virtual]`

create a new decryption filter

Note:
  caller is responsible for deleting the returned pointer

Definition at line 612 of file cryptlib.cpp.

virtual size_t PK_CryptoSystem::MaxPlaintextLength | ( | size_t | ciphertextLength | ) | const`[pure virtual, inherited]`

maximum length of plaintext for a given ciphertext length

Note:
  This function returns 0 if ciphertextLength is not valid (too long or too short).

Implemented in PK_FixedLengthCryptoSystemImpl< PK_Encryptor >, PK_FixedLengthCryptoSystemImpl< PK_Decryptor >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< SCHEME_OPTIONS::Element > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< T > >, DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< SCHEME_OPTIONS::Element > >, and DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< T > >.

Referenced by PK_DefaultDecryptionFilter::Put2().

virtual size_t PK_CryptoSystem::CiphertextLength | ( | size_t | plaintextLength | ) | const`[pure virtual, inherited]`

calculate length of ciphertext given length of plaintext

Note:
  This function returns 0 if plaintextLength is not valid (too long).

Implemented in PK_FixedLengthCryptoSystemImpl< PK_Encryptor >, PK_FixedLengthCryptoSystemImpl< PK_Decryptor >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< SCHEME_OPTIONS::Element > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< T > >, DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< SCHEME_OPTIONS::Element > >, and DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< T > >.

Referenced by PK_DefaultEncryptionFilter::Put2().

virtual bool PK_CryptoSystem::ParameterSupported | ( | const char * | name | ) | const`[pure virtual, inherited]`

this object supports the use of the parameter with the given name

some possible parameter names: EncodingParameters, KeyDerivationParameters

Implemented in TF_CryptoSystemBase< PK_Decryptor, TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >, TF_CryptoSystemBase< PK_Encryptor, TF_Base< RandomizedTrapdoorFunction, PK_EncryptionMessageEncodingMethod > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< SCHEME_OPTIONS::Element > >, DL_CryptoSystemBase< PK_Decryptor, DL_PrivateKey< T > >, DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< SCHEME_OPTIONS::Element > >, and DL_CryptoSystemBase< PK_Encryptor, DL_PublicKey< T > >.

virtual size_t PK_CryptoSystem::FixedCiphertextLength | ( |  | ) | const`[inline, virtual, inherited]`

return fixed ciphertext length, if one exists, otherwise return 0

Note:
  "Fixed" here means length of ciphertext does not depend on length of plaintext. It usually does depend on the key length.

Reimplemented in TF_CryptoSystemBase< PK_Decryptor, TF_Base< TrapdoorFunctionInverse, PK_EncryptionMessageEncodingMethod > >, and TF_CryptoSystemBase< PK_Encryptor, TF_Base< RandomizedTrapdoorFunction, PK_EncryptionMessageEncodingMethod > >.

Definition at line 1146 of file cryptlib.h.

Referenced by FixedLengthDecrypt().

The documentation for this class was generated from the following files:

- cryptlib.h
- cryptlib.cpp